#include <hmg.ch>

PROCEDURE edit_PAYMENT

   PUBLIC NewRec := .F. , EditRec := .F. , _qry_exp := ""

   set procedure to lov_2

   use_COST()
   Use_payment() 
   pack
      
   DEFINE WINDOW Win_2 ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 700 ;
      TITLE "Table PAYMENT" ;
      MODAL ; 
      ON RELEASE dbcloseall()

      ON KEY ESCAPE ACTION Win_2.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Table PAYMENT"
         *KEYBOARD
         DATE
         CLOCK
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_2 BUTTONSIZE 60,40 IMAGESIZE 32,32 FLAT BORDER

      BUTTON FIRST_4946 ;
         CAPTION "First" ;
         PICTURE "go_first" ;
         ACTION( dbGotop(), Win_2.Browse_2.Value := RecNo() )

      BUTTON PREV_4946 ;
         CAPTION "Prev" ;
         PICTURE "go_prev" ;
         ACTION( dbSkip( -1 ), Win_2.Browse_2.Value := RecNo() )

      BUTTON NEXT_4946 ;
         CAPTION "Next" ;
         PICTURE "go_next" ;
         ACTION( dbSkip(), if ( Eof(), dbGobottom(), Nil ), Win_2.Browse_2.Value := RecNo() )

      BUTTON LAST_4946 ;
         CAPTION "Last" ;
         PICTURE "go_last" ;
         ACTION( dbGoBottom(), Win_2.Browse_2.Value := RecNo() )   SEPARATOR 

      BUTTON FIND_4946 ;
         CAPTION "Find" ;
         PICTURE "edit_find" ;
         ACTION Find_4946()

      BUTTON NEW_4946 ;
         CAPTION "New" ;
         PICTURE "edit_new" ;
         ACTION ( NewRec := .T., EditRec = .F., NewRecord_4946() )

      BUTTON EDIT_4946 ;
         CAPTION "Edit" ;
         PICTURE "edit_edit" ;
         ACTION ( EditRec := .T., NewRec := .F., If ( RecordStatus_4946(), EnableField_4946(), Nil ))

      BUTTON DELETE_4946 ;
         CAPTION "Delete" ;
         PICTURE "edit_delete" ;
         ACTION ( RecordStatus_4946(), DeleteRecord_4946(), Nil )

      BUTTON PRINT_4946 ;
         CAPTION "Print" ;
         PICTURE "edit_print" ;
         ACTION PrintData_4946()

      BUTTON EXIT_4946 ;
         CAPTION "Exit" ;
         PICTURE "edit_close" ;
         ACTION Win_2.Release

      END TOOLBAR

      PaintDisplay_4946()

      @ 90,10 BROWSE Browse_2 ;
         OF Win_2 ;
         WIDTH 750 ;
         HEIGHT 320 ;
         FONT "Arial" ; 
         SIZE 11 ;
         HEADERS { "DATE(1)","PAY_ID","DESCRIPT","EXPENSE","PAYMENT","DATE(2)" } ;
         WIDTHS { 110,70,210,110,110,110 } ;
         WORKAREA PAYMENT ;
         FIELDS { "DATE1","PAY_ID","DESCRIPT","EXPENSE","PAYMENT","DATE2" } ;
         ON CHANGE LoadData_4946() ;
         ON HEADCLICK { {||head1_4946()}, {||head2_4946()} } ;
         ON DBLCLICK ( EnableField_4946(), If ( ! RecordStatus_4946(), DisableField_4946(), Nil ) ) ;
         JUSTIFY { , BROWSE_JTFY_RIGHT, , BROWSE_JTFY_RIGHT, BROWSE_JTFY_RIGHT, , , } 

      @ 580, 50 BUTTON SAVE_4946 ;
         CAPTION "Save" ;
         PICTURE "ok" RIGHT ;
         ACTION SaveRecord_4946() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,300 BUTTON QUERY_4946 ;
         CAPTION "Query" ;
         PICTURE "edit_find" RIGHT ;
         ACTION QueryRecord_4946() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,150 BUTTON CANCEL_4946 ;
         CAPTION "Cancel" ;
         PICTURE "cancel" RIGHT ;
         ACTION CancelEdit_4946() ;
         WIDTH 100 ;
         HEIGHT 40 

   END WINDOW

   DisableField_4946()

   Win_2.Browse_2.SetFocus
   Win_2.Browse_2.Value := PAYMENT->(RecNo())

   ACTIVATE WINDOW Win_2

RETURN
*:---------------------------------------------*
PROCEDURE DisableField_4946

   Win_2.Browse_2.Enabled      := .T.
   Win_2.Query_4946.Visible      := .F.

   Win_2.mDATE1.Enabled        := .F.
   Win_2.mPAY_ID.Enabled       := .F.
   Win_2.mDESCRIPT.Enabled     := .F.
   Win_2.mEXPENSE.Enabled      := .F.
   Win_2.mPAYMENT.Enabled      := .F.
   Win_2.mDATE2.Enabled        := .F.
   Win_2.dDISPLAY.Enabled      := .F.

   Win_2.Save_4946.Enabled     := .F.
   Win_2.Cancel_4946.Enabled   := .F.
   Win_2.Query_4946.Enabled    := .F.
   Win_2.Toolbar_2.Enabled     := .T.
   Win_2.Browse_2.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE EnableField_4946

   Win_2.Browse_2.Enabled      := .F.

   Win_2.mDATE1.Enabled        := .T.
   Win_2.mPAY_ID.Enabled       := .T.
   Win_2.mDESCRIPT.Enabled     := .T.
   Win_2.mEXPENSE.Enabled      := .T.
   Win_2.mPAYMENT.Enabled      := .T.
   Win_2.mDATE2.Enabled        := .T.

   Win_2.Save_4946.Enabled     := .T.
   Win_2.Cancel_4946.Enabled   := .T.
   Win_2.Query_4946.Enabled    := .F.
   Win_2.Toolbar_2.Enabled     := .F.
   Win_2.mPAY_ID.SetFocus

RETURN
*:---------------------------------------------*
FUNCTION RecordStatus_4946()

   Local RetVal

   PAYMENT->( dbGoTo ( Win_2.Browse_2.Value ) )

   IF PAYMENT->(RLock())
      RetVal := .T.
   ELSE
      MsgExclamation ("Record LOCKED, try again later")
      RetVal := .F.
   ENDIF

RETURN RetVal
*:---------------------------------------------*
PROCEDURE LoadData_4946

   PAYMENT->( dbGoTo ( Win_2.Browse_2.Value ) )

   Win_2.mDATE1.Value        := PAYMENT->DATE1     
   Win_2.mPAY_ID.Value       := PAYMENT->PAY_ID    

   SELECT cost
   SEEK Win_2.mPAY_ID.Value
   IF FOUND()
      Win_2.dDISPLAY.Value := DESCRIPT
   ELSE
      Win_2.dDISPLAY.Value := "???"
   ENDIF

   SELECT payment
   Win_2.mDESCRIPT.Value     := PAYMENT->DESCRIPT  
   Win_2.mEXPENSE.Value      := PAYMENT->EXPENSE   
   Win_2.mPAYMENT.Value      := PAYMENT->PAYMENT   
   Win_2.mDATE2.Value        := PAYMENT->DATE2     

RETURN
*:---------------------------------------------*
PROCEDURE CancelEdit_4946

   DisableField_4946()
   LoadData_4946()
   UNLOCK
   NewRec := .F.

RETURN
*:---------------------------------------------*
PROCEDURE SaveRecord_4946

   Local NewRecNo

   DisableField_4946()

   IF NewRec == .T.
      PAYMENT->(dbAppend())
      NewRec := .F.
   ELSE
      PAYMENT->(dbGoto ( Win_2.Browse_2.Value ) )
   ENDIF

   NewRecNo := PAYMENT->( RecNo() )

   PAYMENT->DATE1      := Win_2.mDATE1.Value
   PAYMENT->PAY_ID     := Win_2.mPAY_ID.Value
   PAYMENT->DESCRIPT   := Win_2.mDESCRIPT.Value
   PAYMENT->EXPENSE    := Win_2.mEXPENSE.Value
   PAYMENT->PAYMENT    := Win_2.mPAYMENT.Value
   PAYMENT->DATE2      := Win_2.mDATE2.Value

   Win_2.Browse_2.Refresh
   IF NewRec == .T.
      Win_2.Browse_2.Value := NewRecNo 
   ENDIF

   UNLOCK
   dbCommitall()

   Win_2.StatusBar.Item(1) := "Save Record" 

RETURN
*:---------------------------------------------*
PROCEDURE NewRecord_4946

   Win_2.StatusBar.Item(1) := "Editing" 

   SET ORDER TO 1
   dbGoBottom()

   Win_2.mDATE1.Value        := date()
   Win_2.mPAY_ID.Value       := 0
   Win_2.mDESCRIPT.Value     := space(20)
   Win_2.mEXPENSE.Value      := 0
   Win_2.mPAYMENT.Value      := 0
   Win_2.mDATE2.Value        := date()

   EnableField_4946()

   Win_2.mPAY_ID.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE DeleteRecord_4946

   IF MsgYesNo ( "Are you sure do you want delete record?" )
      IF PAYMENT->(FLock())
         DELETE
         Win_2.Browse_2.Refresh
         UNLOCK
      ENDIF
   ENDIF

RETURN
*:---------------------------------------------*
PROCEDURE Find_4946

   Win_2.StatusBar.Item(1) := "Query" 
   Win_2.Query_4946.Visible := .T.

   Win_2.mDATE1.Value        := date()
   Win_2.mPAY_ID.Value       := 0
   Win_2.mDESCRIPT.Value     := space(20)
   Win_2.mEXPENSE.Value      := 0
   Win_2.mPAYMENT.Value      := 0
   Win_2.mDATE2.Value        := date()

   EnableField_4946()
   Win_2.Save_4946.Enabled  := .F.
   Win_2.Query_4946.Enabled := .T.
   Win_2.mDATE1.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE PrintData_4946

   Local RecRec 

   RecRec := PAYMENT->( RecNo())
   dbGoTop()
   DO REPORT ;
      TITLE "PAYMENT" ;
      HEADERS { "","","","","","" }, { "DATE1","PAY_ID","DESCRIPT","EXPENSE","PAYMENT","DATE2" } ;
      FIELDS { "DATE1","PAY_ID","DESCRIPT","EXPENSE","PAYMENT","DATE2" } ;
      WIDTHS { 11,7,21,11,11,11 } ;
      TOTALS { .F.,.F.,.F.,.F.,.F.,.F. } ;
      WORKAREA PAYMENT ;
      LPP 50 ;
      CPL 80 ;
      LMARGIN 5 ;
      PREVIEW
   PAYMENT->(dbGoTo(RecRec))

RETURN
*:---------------------------------------------*
PROCEDURE PaintDisplay_4946

   @ 440, 10 FRAME Frame_2 WIDTH 750 HEIGHT 120

   @ 450,  20 LABEL Label_1 VALUE "DATUM"
   @ 450, 110 LABEL Label_2 VALUE "PAY"
   @ 450, 200 LABEL Label_3 VALUE "DESCRIPTION"
   @ 450, 380 LABEL Label_4 VALUE "EXPENSE"
   @ 450, 490 LABEL Label_5 VALUE "PAYMENT"
   @ 450, 600 LABEL Label_6 VALUE "DATE2"
   *@ 280, 420 LABEL Label_7 VALUE "DISPLAY"

   @ 470,  20 TEXTBOX  mDATE1       WIDTH 80 DATE 
   @ 470, 110 TEXTBOX  mPAY_ID      WIDTH 40 NUMERIC INPUTMASK "999" on enter valid_2_2("E") on lostfocus valid_2_2("F")
   @ 500, 110 TEXTBOX  dDISPLAY     WIDTH 150
   @ 470, 200 TEXTBOX  mDESCRIPT    WIDTH 170 INPUTMASK "!!!!!!!!!!!!!!!!!!!!"
   @ 470, 380 TEXTBOX  mEXPENSE     WIDTH 100 NUMERIC INPUTMASK "999,999.99"
   @ 470, 490 TEXTBOX  mPAYMENT     WIDTH 100 NUMERIC INPUTMASK "999,999.99"
   @ 470, 600 TEXTBOX  mDATE2       DATE 
   
RETURN
*:---------------------------------------------*
PROCEDURE Head1_4946

   SELECT PAYMENT
   SET ORDER TO 1
   dbGotop()
   Win_2.Browse_2.Value := RecNo()
   Win_2.Browse_2.Refresh
   LoadData_4946()

RETURN
*:---------------------------------------------*
PROCEDURE Head2_4946

   SELECT PAYMENT
   SET ORDER TO 2
   dbGotop()
   Win_2.Browse_2.Value := RecNo()
   Win_2.Browse_2.Refresh
   LoadData_4946()

RETURN
*:---------------------------------------------*
PROCEDURE QueryRecord_4946

   PreQuery_4946()

   SET FILTER TO &_qry_exp
   dbGotop()

   IF ! EMPTY( _qry_exp )
      COUNT TO found_rec FOR &_qry_exp
      dbGotop()

      IF found_rec = 0
         Win_2.Statusbar.Item(1) := "Not found!"
      ELSE
         Win_2.Statusbar.Item(1) := "Found " + ALLTRIM(STR(found_rec)) + " record(s)!"
      ENDIF
   ENDIF

   DisableField_4946()

   Win_2.Browse_2.Refresh
   Win_2.Browse_2.Enabled   := .T.

RETURN
*:---------------------------------------------*
PROCEDURE PreQuery_4946

_qry_exp := ""
_ima_filter := .F.

IF ! EMPTY ( Win_2.mDATE1.Value )     // DATE1
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DATE1 = " + "CTOD(" + chr(34) + DTOC(Win_2.mDATE1.Value) + chr(34) + ")"
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mPAY_ID.Value )     // PAY_ID
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "PAY_ID = " + STR( Win_2.mPAY_ID.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mDESCRIPT.Value )     // DESCRIPT
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DESCRIPT = " + chr(34) + Win_2.mDESCRIPT.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mEXPENSE.Value )     // EXPENSE
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "EXPENSE = " + STR( Win_2.mEXPENSE.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mPAYMENT.Value )     // PAYMENT
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "PAYMENT = " + STR( Win_2.mPAYMENT.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mDATE2.Value )     // DATE2
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DATE2 = " + "CTOD(" + chr(34) + DTOC(Win_2.mDATE2.Value) + chr(34) + ")"
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mDISPLAY.Value )     // DISPLAY
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DISPLAY = " + chr(34) + Win_2.mDISPLAY.Value + chr(34)
      _ima_filter := .T.
ENDIF

RETURN
*:*********************************
FUNCTION valid_2_2 ( _p1 )

SELECT cost      
SEEK Win_2.mPAY_ID.Value
IF FOUND()
   Win_2.dDISPLAY.Value := DESCRIPT  
   SELECT payment 
   RETURN .T.
ELSE
   IF _p1 = "E"
      SEEK Win_2.mPAY_ID.Value 
      IF !FOUND()
         Win_2.mPAY_ID.Value := lov_2_2()
      ENDIF

      dbcloseall()
      use_PAYMENT()
      use_COST()

      SEEK Win_2.mPAY_ID.Value 
      SELECT payment 
      RETURN .T.
   ENDIF
ENDIF

RETURN .F.
