#include <hmg.ch>

PROCEDURE MAIN 

   SET century on
   SET date german
   SET interactiveclose on
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon

   DEFINE WINDOW MainForm ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 600 ;
      TITLE "Budget" ;
      MAIN ;
      ICON "budget" ;
      ON INIT on_start() ;
      ON RELEASE dbcloseall()

      ON KEY ESCAPE ACTION MainForm.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Keyboard status"
         *KEYBOARD
         DATE
         CLOCK
      END STATUSBAR

      DEFINE MAIN MENU

         DEFINE POPUP "Data"
            MENUITEM "Costs"               ACTION edit_cost()
            MENUITEM "Payments"            ACTION edit_payment()
            SEPARATOR 
            MENUITEM "Cost and payment"    ACTION edit_cost_pay()
            SEPARATOR 
            MENUITEM "Exit"                ACTION MainForm.Release
         END POPUP 

         DEFINE POPUP "Reports"
            MENUITEM "Balances"            ACTION report_a()
            MENUITEM "Items"               ACTION report_b()
         END POPUP 

      END MENU

   END WINDOW

   ACTIVATE WINDOW MainForm

RETURN
*:---------------------------------------------*
PROCEDURE on_start

   open_dbf()
   open_ntx()

RETURN
* end of program *