#include <hmg.ch>

PROCEDURE edit_COST

   PUBLIC NewRec := .F. , EditRec := .F. , _qry_exp := ""

   Use_cost() 

   DEFINE WINDOW Win_1 ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 700 ;
      TITLE "Table COST" ;
      MODAL ;
      ON RELEASE dbcloseall()

      ON KEY ESCAPE ACTION Win_1.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Table COST"
         *KEYBOARD
         DATE
         CLOCK
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 60,40 IMAGESIZE 32,32 FLAT BORDER

      BUTTON FIRST_1484 ;
         CAPTION "First" ;
         PICTURE "go_first" ;
         ACTION( dbGotop(), Win_1.Browse_1.Value := RecNo() )

      BUTTON PREV_1484 ;
         CAPTION "Prev" ;
         PICTURE "go_prev" ;
         ACTION( dbSkip( -1 ), Win_1.Browse_1.Value := RecNo() )

      BUTTON NEXT_1484 ;
         CAPTION "Next" ;
         PICTURE "go_next" ;
         ACTION( dbSkip(), if ( Eof(), dbGobottom(), Nil ), Win_1.Browse_1.Value := RecNo() )

      BUTTON LAST_1484 ;
         CAPTION "Last" ;
         PICTURE "go_last" ;
         ACTION( dbGoBottom(), Win_1.Browse_1.Value := RecNo() )   SEPARATOR 

      BUTTON FIND_1484 ;
         CAPTION "Find" ;
         PICTURE "edit_find" ;
         ACTION Find_1484()

      BUTTON NEW_1484 ;
         CAPTION "New" ;
         PICTURE "edit_new" ;
         ACTION ( NewRec := .T., EditRec = .F., NewRecord_1484() )

      BUTTON EDIT_1484 ;
         CAPTION "Edit" ;
         PICTURE "edit_edit" ;
         ACTION ( EditRec := .T., NewRec := .F., If ( RecordStatus_1484(), EnableField_1484(), Nil ))

      BUTTON DELETE_1484 ;
         CAPTION "Delete" ;
         PICTURE "edit_delete" ;
         ACTION ( RecordStatus_1484(), DeleteRecord_1484(), Nil )

      BUTTON PRINT_1484 ;
         CAPTION "Print" ;
         PICTURE "edit_print" ;
         ACTION PrintData_1484()

      BUTTON EXIT_1484 ;
         CAPTION "Exit" ;
         PICTURE "edit_close" ;
         ACTION Win_1.Release

      END TOOLBAR

      PaintDisplay_1484()

      @ 90,10 BROWSE Browse_1 ;
         OF Win_1 ;
         WIDTH 350 ;
         HEIGHT 450 ;
         FONT "Arial" ; 
         SIZE 11 ;
         HEADERS { "PAY","DESCRIPT" } ;
         WIDTHS { 40,210 } ;
         WORKAREA COST ;
         FIELDS { "PAY","DESCRIPT" } ;
         ON CHANGE LoadData_1484() ;
         ON HEADCLICK { {||head1_1484()}, {||head2_1484()} } ;
         ON DBLCLICK ( EnableField_1484(), If ( ! RecordStatus_1484(), DisableField_1484(), Nil ) ) ;
         JUSTIFY { BROWSE_JTFY_RIGHT, , } 

      @ 580, 50 BUTTON SAVE_1484 ;
         CAPTION "Save" ;
         PICTURE "ok" RIGHT ;
         ACTION SaveRecord_1484() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,300 BUTTON QUERY_1484 ;
         CAPTION "Query" ;
         PICTURE "edit_find" RIGHT ;
         ACTION QueryRecord_1484() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,150 BUTTON CANCEL_1484 ;
         CAPTION "Cancel" ;
         PICTURE "cancel" RIGHT ;
         ACTION CancelEdit_1484() ;
         WIDTH 100 ;
         HEIGHT 40 

   END WINDOW

   DisableField_1484()

   Win_1.Browse_1.SetFocus
   Win_1.Browse_1.Value := COST->(RecNo())

   ACTIVATE WINDOW Win_1

RETURN
*:---------------------------------------------*
PROCEDURE DisableField_1484

   Win_1.Browse_1.Enabled      := .T.
   Win_1.Query_1484.Visible      := .F.

   Win_1.mPAY.Enabled          := .F.
   Win_1.mDESCRIPT.Enabled     := .F.

   Win_1.Save_1484.Enabled     := .F.
   Win_1.Cancel_1484.Enabled   := .F.
   Win_1.Query_1484.Enabled    := .F.
   Win_1.Toolbar_1.Enabled     := .T.
   Win_1.Browse_1.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE EnableField_1484

   Win_1.Browse_1.Enabled      := .F.

   Win_1.mPAY.Enabled          := .T.
   Win_1.mDESCRIPT.Enabled     := .T.

   Win_1.Save_1484.Enabled     := .T.
   Win_1.Cancel_1484.Enabled   := .T.
   Win_1.Query_1484.Enabled    := .F.
   Win_1.Toolbar_1.Enabled     := .F.
   Win_1.mDESCRIPT.SetFocus

RETURN
*:---------------------------------------------*
FUNCTION RecordStatus_1484()

   Local RetVal

   COST->( dbGoTo ( Win_1.Browse_1.Value ) )

   IF COST->(RLock())
      RetVal := .T.
   ELSE
      MsgExclamation ("Record LOCKED, try again later")
      RetVal := .F.
   ENDIF

RETURN RetVal
*:---------------------------------------------*
PROCEDURE LoadData_1484

   COST->( dbGoTo ( Win_1.Browse_1.Value ) )

   Win_1.mPAY.Value          := COST->PAY       
   Win_1.mDESCRIPT.Value     := COST->DESCRIPT  

RETURN
*:---------------------------------------------*
PROCEDURE CancelEdit_1484

   DisableField_1484()
   LoadData_1484()
   UNLOCK
   NewRec := .F.

RETURN
*:---------------------------------------------*
PROCEDURE SaveRecord_1484

   Local NewRecNo

   DisableField_1484()

   IF NewRec == .T.
      COST->(dbAppend())
      NewRec := .F.
   ELSE
      COST->(dbGoto ( Win_1.Browse_1.Value ) )
   ENDIF

   NewRecNo := COST->( RecNo() )

   COST->PAY        := Win_1.mPAY.Value
   COST->DESCRIPT   := Win_1.mDESCRIPT.Value

   Win_1.Browse_1.Refresh
   IF NewRec == .T.
      Win_1.Browse_1.Value := NewRecNo 
   ENDIF

   UNLOCK
   dbCommitall()

   Win_1.StatusBar.Item(1) := "Save Record" 

RETURN
*:---------------------------------------------*
PROCEDURE NewRecord_1484

   Win_1.StatusBar.Item(1) := "Editing" 

   SET ORDER TO 1
   dbGoTop()
   dbGoBottom()
   _next = pay + 1
      
   Win_1.mPAY.Value          := _next
   Win_1.mDESCRIPT.Value     := space(20)

   EnableField_1484()

   Win_1.mDESCRIPT.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE DeleteRecord_1484

   IF MsgYesNo ( "Are you sure do you want delete record?" )
      IF COST->(FLock())
         DELETE
         Win_1.Browse_1.Refresh
         UNLOCK
      ENDIF
   ENDIF

RETURN
*:---------------------------------------------*
PROCEDURE Find_1484

   Win_1.StatusBar.Item(1) := "Query" 
   Win_1.Query_1484.Visible := .T.

   Win_1.mPAY.Value          := 0
   Win_1.mDESCRIPT.Value     := space(20)

   EnableField_1484()
   Win_1.Save_1484.Enabled  := .F.
   Win_1.Query_1484.Enabled := .T.
   Win_1.mPAY.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE PrintData_1484

   Local RecRec 

   RecRec := COST->( RecNo())
   dbGoTop()
   DO REPORT ;
      TITLE "COST" ;
      HEADERS { "","" }, { "PAY","DESCRIPT" } ;
      FIELDS { "PAY","DESCRIPT" } ;
      WIDTHS { 4,21 } ;
      TOTALS { .F.,.F. } ;
      WORKAREA COST ;
      LPP 50 ;
      CPL 80 ;
      LMARGIN 5 ;
      PREVIEW
   COST->(dbGoTo(RecRec))

RETURN
*:---------------------------------------------*
PROCEDURE PaintDisplay_1484

   @  90,410 FRAME Frame_1 WIDTH 350 HEIGHT 450

   @ 100, 420 LABEL Label_1 VALUE "PAY"
   @ 130, 420 LABEL Label_2 VALUE "DESCRIPT"

   @ 100, 520 TEXTBOX  mPAY         WIDTH 40 NUMERIC INPUTMASK "999"
   @ 130, 520 TEXTBOX  mDESCRIPT    WIDTH 210 INPUTMASK "!!!!!!!!!!!!!!!!!!!!"

RETURN
*:---------------------------------------------*
PROCEDURE Head1_1484

   SELECT COST
   SET ORDER TO 1
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_1484()

RETURN
*:---------------------------------------------*
PROCEDURE Head2_1484

   SELECT COST
   SET ORDER TO 2
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_1484()

RETURN
*:---------------------------------------------*
PROCEDURE QueryRecord_1484

   PreQuery_1484()

   SET FILTER TO &_qry_exp
   dbGotop()

   IF ! EMPTY( _qry_exp )
      COUNT TO found_rec FOR &_qry_exp
      dbGotop()

      IF found_rec = 0
         Win_1.Statusbar.Item(1) := "Not found!"
      ELSE
         Win_1.Statusbar.Item(1) := "Found " + ALLTRIM(STR(found_rec)) + " record(s)!"
      ENDIF
   ENDIF

   DisableField_1484()

   Win_1.Browse_1.Refresh
   Win_1.Browse_1.Enabled   := .T.

RETURN
*:---------------------------------------------*
PROCEDURE PreQuery_1484

_qry_exp := ""
_ima_filter := .F.

IF ! EMPTY ( Win_1.mPAY.Value )     // PAY
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "PAY = " + STR( Win_1.mPAY.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mDESCRIPT.Value )     // DESCRIPT
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DESCRIPT = " + chr(34) + Win_1.mDESCRIPT.Value + chr(34)
      _ima_filter := .T.
ENDIF

RETURN
*:*********************************