#include <hmg.ch>

STATIC aGrid := {} , _qry_exp := ""

PROCEDURE edit_COST_pay

   use_PAYMENT() 
   use_COST() 

   SET FILTER TO PAY > 0
   DBGOTOP()

   DEFINE WINDOW MD_Form_1 ;
      AT 10,10 ;
      WIDTH 800 ;
      HEIGHT 600 ;
      TITLE "Master / Detail Form" ;
      MODAL ;
      ON INIT RefreshWin_2014() ;
      ON RELEASE dbcloseall()

      ON KEY ESCAPE ACTION MD_Form_1.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Master / Detail"
      END STATUSBAR

      PaintDisplay_2014()
      @ 160, 700 BUTTON cmd1Qry CAPTION "Query" ACTION Query1Rec_2014() WIDTH 60 HEIGHT 25
      DisableFields_2014()

      @ 160,  10 BUTTON cmd1Top CAPTION "<< First" ACTION MoveRec_2014(0) WIDTH 60 HEIGHT 25
      @ 160,  80 BUTTON cmd1Prv CAPTION "< Prev" ACTION MoveRec_2014(-1) WIDTH 60 HEIGHT 25
      @ 160, 150 BUTTON cmd1Nxt CAPTION "Next >" ACTION MoveRec_2014(1) WIDTH 60 HEIGHT 25
      @ 160, 220 BUTTON cmd1End CAPTION "End >>" ACTION MoveRec_2014(99) WIDTH 60 HEIGHT 25
      @ 160, 290 BUTTON cmd1Fnd CAPTION "Find" ACTION Find1Rec_2014() WIDTH 60 HEIGHT 25
      @ 160, 360 BUTTON cmd1Edt CAPTION "Edit" ACTION Mas_Edit_1("E") WIDTH 60 HEIGHT 25
      @ 160, 430 BUTTON cmd1New CAPTION "New" ACTION Mas_Edit_1("N") WIDTH 60 HEIGHT 25
      @ 160, 500 BUTTON cmd1Del CAPTION "Delete" ACTION Mas_Edit_1("D") WIDTH 60 HEIGHT 25
      @ 160, 570 BUTTON cmd1Ext CAPTION "Exit" ACTION Exit_2014() WIDTH 60 HEIGHT 25

      @ 200,10 GRID MD_Grid_1 ;
         WIDTH 750 ;
         HEIGHT 250 ;
         HEADERS { "Recno","DATE1","DESCRIPT","EXPENSE","PAYMENT","DATE2" } ;
         WIDTHS { 0,110,210,110,110,110 } ;
         JUSTIFY { 1,0,0,1,1,0 } 

      @ 460, 300 LABEL lSum value "SUM"
      @ 460, 350 TEXTBOX nSum_1 WIDTH 95 NUMERIC INPUTMASK "999,999.99"
      @ 460, 460 TEXTBOX nSum_2 WIDTH 95 NUMERIC INPUTMASK "999,999.99"

      @ 500,  10 BUTTON cmd2Edt CAPTION "Edit" ACTION Det_Edit_1("E") WIDTH 100 HEIGHT 30
      @ 500, 120 BUTTON cmd2New CAPTION "New" ACTION Det_Edit_1("N") WIDTH 100 HEIGHT 30
      @ 500, 230 BUTTON cmd2Del CAPTION "Delete" ACTION Det_Edit_1("D") WIDTH 100 HEIGHT 30
      @ 500, 340 BUTTON cmd2Ext CAPTION "Exit" ACTION Exit_2014() WIDTH 100 HEIGHT 30

   END WINDOW

   ACTIVATE WINDOW MD_Form_1

RETURN
*:---------------------------------------------*
FUNCTION DisableFields_2014()

   MD_Form_1.cmd1Qry.Visible := .F.
   MD_Form_1.cmd1Qry.Enabled := .F.

   MD_Form_1.mPAY.Enabled          := .F.
   MD_Form_1.mDESCRIPT.Enabled     := .F.

RETURN 0
*:---------------------------------------------*
FUNCTION EnableFields_2014()

   MD_Form_1.mPAY.Enabled          := .T.
   MD_Form_1.mDESCRIPT.Enabled     := .T.

RETURN 0
*:---------------------------------------------*
FUNCTION PaintDisplay_2014()

   @ 10,10 FRAME frame_1 WIDTH 770 HEIGHT 140 

   @ 30, 20 LABEL lPAY          VALUE "PAY"
   @ 30, 60 LABEL lDESCRIPT     VALUE "DESCRIPT"

   @ 50, 20 TEXTBOX mPAY          WIDTH 35 NUMERIC
   @ 50, 60 TEXTBOX mDESCRIPT     WIDTH 205

RETURN 0
*:---------------------------------------------*
FUNCTION RefreshWin_2014()

   MD_Form_1.mPAY.Value          := COST->PAY
   MD_Form_1.mDESCRIPT.Value     := COST->DESCRIPT

   _key1 := COST->PAY

   aGrid := {}

   Sum_1 := 0
   Sum_2 := 0
   SELECT PAYMENT 
   dbgotop()
   DO WHILE .NOT. EOF()
      IF _key1 != PAYMENT->PAY_ID
         DBSKIP()
         LOOP
      ENDIF
      Aadd(aGrid, {str(recno()),dtoc(DATE1),DESCRIPT,str(EXPENSE),str(PAYMENT),dtoc(DATE2)})
      Sum_1 = Sum_1 + EXPENSE
      Sum_2 = Sum_2 + PAYMENT
      DBSKIP()
   ENDDO
   MD_Form_1.nSum_1.Value := Sum_1
   MD_Form_1.nSum_2.Value := Sum_2
   MD_Form_1.MD_Grid_1.DeleteAllItems()
   FOR i = 1 to LEN(aGrid)
      MD_Form_1.MD_Grid_1.AddItem(aGrid[i])
   NEXT
   SELECT COST    

RETURN 0
*:---------------------------------------------*
FUNCTION MoveRec_2014( _direct )

   SELECT COST    

   DO CASE
      CASE _direct = 0 // first rec
         DBGOTOP()

      CASE _direct = -1 // prev rec
         DBSKIP(-1)
         IF BOF()
            DBGOTOP()
         ENDIF

      CASE _direct = 1 // next rec
         DBSKIP()
         IF EOF()
            DBGOBOTTOM()
         ENDIF

      CASE _direct = 99 // last rec
         DBGOBOTTOM()

   END CASE

   RefreshWin_2014()

RETURN 0
*:---------------------------------------------*
FUNCTION Exit_2014()

   DbCloseAll()
   MD_Form_1.Release

RETURN 0
*:---------------------------------------------*
FUNCTION Find1Rec_2014()

   MD_Form_1.StatusBar.Item(1) := "Query"

   MD_Form_1.mPAY.Value           := 0
   MD_Form_1.mDESCRIPT.Value      := space(20)

   EnableFields_2014()

   MD_Form_1.cmd1Qry.Visible := .T.
   MD_Form_1.cmd1Qry.Enabled := .T.
   MD_Form_1.mPAY.SetFocus

RETURN 0
*:---------------------------------------------*
FUNCTION Query1Rec_2014()

   PreQuery1Rec_2014()

   SET FILTER TO &_qry_exp
   dbGoTop()

   IF ! EMPTY( _qry_exp )
      COUNT TO found_rec FOR &_qry_exp
      dbGotop()

      IF found_rec = 0
         MD_Form_1.Statusbar.Item(1) := "Not found!"
      ELSE
         MD_Form_1.Statusbar.Item(1) := "Found " + ALLTRIM(STR(found_rec)) + " record(s)!"
      ENDIF
   ENDIF
   DisableFields_2014()
   RefreshWin_2014()

RETURN 0
*:---------------------------------------------*
FUNCTION PreQuery1Rec_2014()

_qry_exp := ""
_ima_filter := .F.

IF ! EMPTY ( MD_Form_1.mPAY.Value )     // PAY
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "PAY = " + STR( MD_Form_1.mPAY.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( MD_Form_1.mDESCRIPT.Value )     // DESCRIPT
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DESCRIPT = " + chr(34) + MD_Form_1.mDESCRIPT.Value + chr(34)
      _ima_filter := .T.
ENDIF

RETURN 0
*:*********************************************
*                                             *
* master block                                *
*                                             *
*:*********************************************
FUNCTION Mas_Edit_1( _do_it  )

   PRIVATE _status := _do_it, _rec_no := recno()

      IF _status = "D"
         Delete1Rec_1()
         RETURN
      ENDIF

   DEFINE WINDOW Mas_Form_1 ;
      AT 0,0 ;
      WIDTH 400 ;
      HEIGHT 700 ;
      TITLE "Edit Master Record" ;
      MODAL ;

      ON KEY ESCAPE ACTION Mas_Form_1.Release

      Paint1Record_2014()
      Disable1Record_2014()
      Load1Data_2014()
      Enable1Record_2014()

   @ 580, 50 BUTTON SAVE_2014; 
      CAPTION "Save" ; 
      PICTURE "ok" RIGHT ;
      ACTION Save1Record_2014() ;
      WIDTH 100 ;
      HEIGHT 40

   @ 580, 160 BUTTON CANCEL_2014; 
      CAPTION "Cancel" ; 
      PICTURE "cancel" RIGHT ;
      ACTION Cancel1Edit_2014() ;
      WIDTH 100 ;
      HEIGHT 40

   END WINDOW 

   CENTER WINDOW Mas_Form_1

   ACTIVATE WINDOW Mas_Form_1

RETURN
*:---------------------------------------------*
FUNCTION Disable1Record_2014()

   Mas_Form_1.mPAY.Enabled         := .F.
   Mas_Form_1.mDESCRIPT.Enabled    := .F.

RETURN
*:---------------------------------------------*
FUNCTION Enable1Record_2014()

   Mas_Form_1.mPAY.Enabled         := .T.
   Mas_Form_1.mDESCRIPT.Enabled    := .T.

RETURN
*:---------------------------------------------*
FUNCTION Paint1Record_2014()

   @ 100, 20 LABEL lPAY          VALUE "PAY"
   @ 130, 20 LABEL lDESCRIPT     VALUE "DESCRIPT"

   @ 100, 120 TEXTBOX mPAY          WIDTH 40 NUMERIC  INPUTMASK "999"
   @ 130, 120 TEXTBOX mDESCRIPT     WIDTH 210 INPUTMASK "!!!!!!!!!!!!!!!!!!!!"

RETURN 0
*:---------------------------------------------*
FUNCTION Load1Data_2014()

   SELECT COST    

   IF _status = "N"
      Mas_Form_1.mPAY.Value           := 0
      Mas_Form_1.mDESCRIPT.Value      := space(20)
   ELSE
      GOTO _rec_no
      Mas_Form_1.mPAY.Value           := COST->PAY
      Mas_Form_1.mDESCRIPT.Value      := COST->DESCRIPT
   ENDIF

RETURN 0
*:---------------------------------------------*
FUNCTION Delete1Rec_1 ()

   SELECT COST    
   GOTO _rec_no

   IF MsgYesNo( "Are you sure do you want delete record?" )

      COST->PAY        := 0
      DBCOMMIT()
      DBGOTOP()
      RefreshWin_2014()

   ENDIF

RETURN 0
*:----------------------------------------------------*
FUNCTION Save1Record_2014 ()

   IF _status = "N"
      SEEK 0
      IF !FOUND()
         DBAPPEND()
      ENDIF
   ENDIF

   COST->PAY          :=  Mas_Form_1.mPAY.Value
   COST->DESCRIPT     :=  Mas_Form_1.mDESCRIPT.Value
   DBUNLOCK()
   DBCOMMIT()

   RefreshWin_2014()
   Cancel1Edit_2014()

RETURN 0
*:---------------------------------------------*
FUNCTION Cancel1Edit_2014 ()

   Mas_Form_1.Release

RETURN 0
*:*********************************************
*                                             *
* detail block                                *
*                                             *
*:*********************************************
FUNCTION Det_Edit_1( _do_it  )

   PRIVATE _status := _do_it, i := MD_Form_1.MD_Grid_1.Value , _rec_no := 0

      IF _status = "D" .and. i = 0
         MsgInfo( "First SELECT record !" )
         RETURN
      ENDIF

      IF _status = "E" .and. i = 0
         MsgInfo( "First SELECT record !" )
         RETURN
      ENDIF

      IF _status != "N"
         _rec_no = val(aGrid[i][1])  // recno() 
         *RETURN
      ENDIF

      IF _status = "D"
         Delete2Rec_1()
         RETURN
      ENDIF

   DEFINE WINDOW Det_Form_1 ;
      AT 0,0 ;
      WIDTH 400 ;
      HEIGHT 700 ;
      TITLE "Edit Detail Record" ;
      MODAL

      ON KEY ESCAPE ACTION Det_Form_1.Release

      Paint2Record_2014()
      Disable2Record_2014()
      Load2Data_2014()
      Enable2Record_2014()

   @ 580, 50 BUTTON SAVE_2014; 
      CAPTION "Save" ; 
      PICTURE "ok" RIGHT ;
      ACTION Save2Record_2014() ;
      WIDTH 100 ;
      HEIGHT 40

   @ 580, 160 BUTTON CANCEL_2014; 
      CAPTION "Cancel" ; 
      PICTURE "cancel" RIGHT ;
      ACTION Cancel2Edit_2014() ;
      WIDTH 100 ;
      HEIGHT 40

   END WINDOW

   CENTER WINDOW Det_Form_1

   ACTIVATE WINDOW Det_Form_1

RETURN
*:---------------------------------------------*
FUNCTION Disable2Record_2014 ()

   Det_Form_1.mDATE1.Enabled        := .F.
   Det_Form_1.mDESCRIPT.Enabled     := .F.
   Det_Form_1.mEXPENSE.Enabled      := .F.
   Det_Form_1.mPAYMENT.Enabled      := .F.
   Det_Form_1.mDATE2.Enabled        := .F.
   Det_Form_1.mPAY_ID.Enabled       := .F.

RETURN 0
*:---------------------------------------------*
FUNCTION Enable2Record_2014 ()

   Det_Form_1.mDATE1.Enabled        := .T.
   Det_Form_1.mDESCRIPT.Enabled     := .T.
   Det_Form_1.mEXPENSE.Enabled      := .T.
   Det_Form_1.mPAYMENT.Enabled      := .T.
   Det_Form_1.mDATE2.Enabled        := .T.
   Det_Form_1.mPAY_ID.Enabled       := .F.

RETURN 0
*:---------------------------------------------*
FUNCTION Paint2Record_2014 ()

   @ 100, 20 LABEL l2DATE1        VALUE "DATE1"
   @ 160, 20 LABEL l2DESCRIPT     VALUE "DESCRIPT"
   @ 190, 20 LABEL l2EXPENSE      VALUE "EXPENSE"
   @ 220, 20 LABEL l2PAYMENT      VALUE "PAYMENT"
   @ 250, 20 LABEL l2DATE2        VALUE "DATE2"
   @ 130, 20 LABEL l2PAY_ID       VALUE "PAY_ID"

   @ 100, 120 TEXTBOX mDATE1        DATE 
   @ 160, 120 TEXTBOX mDESCRIPT     WIDTH 210 INPUTMASK "!!!!!!!!!!!!!!!!!!!!"
   @ 190, 120 TEXTBOX mEXPENSE      WIDTH 110 NUMERIC  INPUTMASK "9999999.99"
   @ 220, 120 TEXTBOX mPAYMENT      WIDTH 110 NUMERIC  INPUTMASK "9999999.99"
   @ 250, 120 TEXTBOX mDATE2        DATE 
   @ 130, 120 TEXTBOX mPAY_ID       WIDTH 40 NUMERIC  INPUTMASK "999"

RETURN 0
*:---------------------------------------------*
FUNCTION Load2Data_2014 ()

   SELECT PAYMENT 

   IF _status = "N"

      Det_Form_1.mDATE1.Value        := date()
      Det_Form_1.mDESCRIPT.Value     := space(20)
      Det_Form_1.mEXPENSE.Value      := 0
      Det_Form_1.mPAYMENT.Value      := 0
      Det_Form_1.mDATE2.Value        := date()
      Det_Form_1.mPAY_ID.Value       := COST->PAY

   ELSE

      GOTO _rec_no
      Det_Form_1.mDATE1.Value        := PAYMENT->DATE1
      Det_Form_1.mDESCRIPT.Value     := PAYMENT->DESCRIPT
      Det_Form_1.mEXPENSE.Value      := PAYMENT->EXPENSE
      Det_Form_1.mPAYMENT.Value      := PAYMENT->PAYMENT
      Det_Form_1.mDATE2.Value        := PAYMENT->DATE2
      Det_Form_1.mPAY_ID.Value       := PAYMENT->PAY_ID
   ENDIF

RETURN 0
*:---------------------------------------------*
FUNCTION Delete2Rec_1 ()

   SELECT PAYMENT 
   GOTO _rec_no

   IF MsgYesNo( "Are you sure do you want delete record?" )

      PAYMENT->PAY_ID     := 0
      DBCOMMIT()
      RefreshWin_2014()

   ENDIF

RETURN 0
*:---------------------------------------------*
FUNCTION Save2Record_2014 ()

   IF _status = "N"
      SEEK 0
      IF !FOUND()
         DBAPPEND()
      ENDIF
   ENDIF

   PAYMENT->DATE1      :=  Det_Form_1.mDATE1.Value
   PAYMENT->DESCRIPT   :=  Det_Form_1.mDESCRIPT.Value
   PAYMENT->EXPENSE    :=  Det_Form_1.mEXPENSE.Value
   PAYMENT->PAYMENT    :=  Det_Form_1.mPAYMENT.Value
   PAYMENT->DATE2      :=  Det_Form_1.mDATE2.Value
   PAYMENT->PAY_ID     :=  Det_Form_1.mPAY_ID.Value

   RefreshWin_2014()
   Cancel2Edit_2014()

RETURN 0
*:---------------------------------------------*
FUNCTION Cancel2Edit_2014 ()

   Det_Form_1.Release

RETURN 0
* end program *
*** end of program ***