#include "hmg.ch"

FUNCTION lov_2_2()

SELECT cost
* USE cost INDEX  pay, descript
_redova = reccount()
_red = 0

PUBLIC aRows [_redova] [4], _RetVal
PUBLIC cPublicSearchString := ""

SET ORDER TO 2
dbgotop()

DO WHILE .not. eof()
   _red++
   _fld1 = str(PAY)
   _fld2 = DESCRIPT
   aRows [_red]:= { _fld1, _fld2, str(_red), str(recno()) }
   dbskip()
ENDDO

   DEFINE WINDOW Lov_Form_2 ; 
      AT 0,0 ; 
      WIDTH 500 ; 
      HEIGHT 300 ; 
      TITLE "Search in grid " ; 
      MODAL  

      @  10, 10 LABEL L1 ; 
         WIDTH 80 ; 
         HEIGHT 20 ; 
         VALUE "Search string:" 

      @  10, 100 Textbox WhatToSearch ; 
         WIDTH 95 ; 
         HEIGHT 20 ; 
         VALUE "???" ; 
         INPUTMASK "!!!!!!!!!" 

      @  10, 200 BUTTON go ; 
         CAPTION "OK" ; 
         ACTION GoSearch_2() ; 
         WIDTH 50 ; 
         HEIGHT 20 

      @  40,10 GRID Lov_Grid_2 ; 
         WIDTH 370 ; 
         HEIGHT 210 ; 
         HEADERS {"Key", "Name", "Record", "Recno()" } ; 
         WIDTHS {100,200,100,100} ; 
         ITEMS aRows ; 
         VALUE 1 ; 
         ON DBLCLICK select_row_2() ; 
         JUSTIFY { GRID_JTFY_LEFT,GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_RIGHT } 

   END WINDOW 

   Lov_Form_2.Lov_Grid_2.SetFocus 

   CENTER WINDOW Lov_Form_2

   CREATE EVENT PROCNAME Proc_OnKey_2() HWND Lov_Form_2.Lov_Grid_2.HANDLE 

   ACTIVATE WINDOW Lov_Form_2

RETURN _Retval 
*:**********************************************
FUNCTION Proc_OnKey_2() 
   STATIC flag := .F. 
   LOCAL hWnd, ch, i 
   LOCAL cLocalSearchString 

   IF flag == .T. 
      RETURN NIL 
   ENDIF 

   flag := .T. 
   ch := HMG_GetLastCharacter(@hWnd) 
   cLocalSearchString := cPublicSearchString + upper(ch) 

   IF hWnd == GetControlHandle ("Lov_Grid_2","Lov_Form_2")
      IF (asc(ch)>31 .and. asc(ch)<128) 
         HMG_CleanLastCharacter() 

         dbgotop() 
         SEEK cLocalSearchString 
         IF found() 
            _rec = recno() 
            _niz = 0 

            FOR ii = 1 TO _redova 
              IF val(aRows[ii][4]) = _rec 
                  i = val(aRows[ii][3]) 
                  EXIT 
              ENDIF 
            NEXT 
         ELSE 
            msginfo("Not found") 
            _len = len(cLocalSearchString) 
            cLocalSearchString = substr(cLocalSearchString,1,_len-1) 
            i = 0 
            dbgotop() 
         ENDIF 

         IF i > 0 
            Lov_Form_2.Lov_Grid_2.Visible := .F. 
            Lov_Form_2.Lov_Grid_2.Value := i 
            Lov_Form_2.Lov_Grid_2.Refresh 
            Lov_Form_2.Lov_Grid_2.Visible := .T. 

            cPublicSearchString := cLocalSearchString 
            Lov_Form_2.WhatToSearch.Value := cPublicSearchString 
         ENDIF 

      ENDIF 

      IF asc(ch) == 8 // backspace 
         cPublicSearchString := left(cPublicSearchString, max(0,len(cPublicSearchString)-1)) 
         Lov_Form_2.WhatToSearch.Value := cPublicSearchString 
         HMG_CleanLastCharacter() 
      ENDIF 
      Lov_Form_2.Lov_Grid_2.SetFocus 
   ENDIF 

   flag := .F. 

RETURN NIL 
*:***********************************************
FUNCTION select_row_2()

   SET ORDER TO 1 
   _Retval = aRows[ Lov_Form_2.Lov_Grid_2.value, 1 ] 
   Lov_Form_2.Release 

RETURN val(_RetVal) 
*:**************************************
FUNCTION GoSearch_2()

cLocalSearchString = rtrim(Lov_Form_2.WhatToSearch.Value) 

SEEK cLocalSearchString 
IF found() 
   _rec = recno() 
   _niz = 0 

   FOR ii = 1 TO _redova 
      IF val(aRows[ii][4]) = _rec 
         i = val(aRows[ii][3]) 
         EXIT 
      ENDIF 
   NEXT 

   IF i > 0 
      Lov_Form_2.Lov_Grid_2.Visible := .F. 
      Lov_Form_2.Lov_Grid_2.Value := i 
      Lov_Form_2.Lov_Grid_2.Refresh 
      Lov_Form_2.Lov_Grid_2.Visible := .T. 

      cPublicSearchString := cLocalSearchString 
      Lov_Form_2.WhatToSearch.Value := cPublicSearchString 
   ENDIF 

ELSE 
   msginfo("Not found") 
   _len = len(cLocalSearchString) 
   cLocalSearchString = substr(cLocalSearchString,1,_len-1) 
   i = 0 
   dbgotop() 
ENDIF 

SET ORDER TO 1 
_Retval = aRows[ Lov_Form_2.Lov_Grid_2.value, 1 ] 
Lov_Form_2.Release 

RETURN 0 
*:***************************************
