#include "hmg.ch"

Procedure Report_a

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   DEFINE WINDOW Rep_1 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      TITLE "REPORT" ;
      MODAL 

      ON KEY ESCAPE ACTION Rep_1.Release 

   @ 150, 150 BUTTON PRINT_5424 ;
      CAPTION " Create report " ;
      ACTION rep_create_5424() ;
      WIDTH 100

   END WINDOW

   Rep_1.CENTER
   ACTIVATE WINDOW Rep_1

RETURN
*----------------------------------------*
PROCEDURE rep_create_5424

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280, nVMargin:=10, nHMargin:=10 
PRIVATE cFontName:="Courier", nFontSize:=10, nFontHeight:=5, nCharWidth:=2.5 

pre_rep1()

USE_REPORT()   // function from USE_DBF.prg 

sumr_03 := 0 
sumr_04 := 0 
sumr_05 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_03 := sumr_03 + EXPENSE   
sumr_04 := sumr_04 + PAYMENT   
sumr_05 := sumr_05 + SALDO     

   IF nCurLine > nPageSize
      hdr_5424()
   ENDIF

   nCurLine += nFontHeight
   nCurCol = nHMargin + 1 * nCharWidth + 6 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAY_ID, "999") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 8 * nCharWidth
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYDESC, "XXXXXXXXXXXXXXXXXXXX") FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 29 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( EXPENSE, "999,999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 40 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYMENT, "999,999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 51 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( SALDO, "999,999.99") FONT cFontName SIZE nFontSize RIGHT

   DBSKIP()
ENDDO
nCurLine += nFontHeight

nCurLine += nFontHeight
nCurCol = nHMargin + 29 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 40 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 51 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5

nCurLine += nFontHeight
nCurCol = nHMargin + 29 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_03, "999,999.99") FONT cFontName SIZE nFontSize BOLD RIGHT
nCurCol = nHMargin + 40 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_04, "999,999.99") FONT cFontName SIZE nFontSize BOLD RIGHT
nCurCol = nHMargin + 51 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_05, "999,999.99") FONT cFontName SIZE nFontSize BOLD RIGHT

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_1.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_5424

nCurPage++
nCurLine := nVMargin

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT cFontName SIZE nFontSize BOLD
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT cFontName SIZE nFontSize BOLD
@ nCurLine, 100 PRINT "BALANCE of PAYMENTS" FONT cFontName SIZE nFontSize+4 CENTER BOLD

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
@ nCurLine, nCurCol PRINT "PAY_ID" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 8 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYDESC" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 29 * nCharWidth
@ nCurLine, nCurCol PRINT "EXPENSE" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 40 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYMENT" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 51 * nCharWidth
@ nCurLine, nCurCol PRINT "SALDO" FONT cFontName SIZE nFontSize BOLD

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
nCurCol2 = nCurCol + 6 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 8 * nCharWidth
nCurCol2 = nCurCol + 20 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 29 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 40 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 51 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5


RETURN 0
*:--------------------------------------------------
function pre_rep1

use_cost()

use_report()
zap

use_payment()

do while .not. eof()

   _pay_id = pay_id
   _expense = expense
   _payment = payment

   select cost
   seek _pay_id
   _paydesc = descript

   select report
   seek _pay_id
   if !found()
      dbappend()
      replace pay_id with _pay_id
      replace paydesc with _paydesc
      replace expense with _expense
      replace payment with _payment
   else
      replace expense with expense + _expense
      replace payment with payment + _payment
   endif

   select payment
   dbskip()
enddo

select report
replace saldo with expense - payment all

dbcloseall()

return
