#include "hmg.ch"
#include "hmg.ch"

Procedure Report_b

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   DEFINE WINDOW Rep_2 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      TITLE "REPORT2" ;
      MODAL 

      ON KEY ESCAPE ACTION Rep_2.Release 

      @ 50, 100  LABEL Label_2 VALUE "DATE1"
      @ 50, 150  TEXTBOX  pDATE1  VALUE DATE()-30     DATE 
      @ 80, 100  LABEL Label_7 VALUE "DATE2"
      @ 80, 150  TEXTBOX  pDATE2  VALUE DATE()        DATE 

   @ 150, 150 BUTTON PRINT_9982 ;
      CAPTION " Create report " ;
      ACTION rep_create_9982() ;
      WIDTH 100

   END WINDOW

   Rep_2.CENTER
   ACTIVATE WINDOW Rep_2

RETURN
*----------------------------------------*
PROCEDURE rep_create_9982

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280, nVMargin:=10, nHMargin:=10 
PRIVATE cFontName:="Courier", nFontSize:=9, nFontHeight:=5, nCharWidth:=2.2

_d1 := Rep_2.pDate1.Value
_d2 := Rep_2.pDate2.Value
pre_rep2( _d1, _d2 )

USE_REPORT2()   // function from USE_DBF.prg 

brk_01    := PAY_ID    
brk_on_01 := .F.
prt_01    := .T.
sum_01_05 := 0 
sum_01_06 := 0 

sumr_05 := 0 
sumr_06 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_05 := sumr_05 + EXPENSE   
sumr_06 := sumr_06 + PAYMENT   

   IF brk_01 <> PAY_ID    
      brk_on_01 := .T.
      prt_01    := .T.
   ENDIF

   IF brk_01 <> PAY_ID .OR. brk_on_01

      nCurLine += nFontHeight
      nCurCol = nHMargin + 1 * nCharWidth
      @ nCurLine, nCurCol PRINT replicate("*",  6) FONT cFontName SIZE nFontSize 
      nCurCol = nHMargin + 61 * nCharWidth
      nCurCol2 = nCurCol + 10 * nCharWidth
      @ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1
      nCurCol = nHMargin + 72 * nCharWidth
      nCurCol2 = nCurCol + 10 * nCharWidth
      @ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1

      nCurLine += nFontHeight
      nCurCol = nHMargin + 1 * nCharWidth
      @ nCurLine, nCurCol PRINT "sum" FONT cFontName SIZE nFontSize
      nCurCol = nHMargin + 61 * nCharWidth + 10 * nCharWidth 
      @ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_05, "999,999.99") FONT cFontName SIZE nFontSize RIGHT
      nCurCol = nHMargin + 72 * nCharWidth + 10 * nCharWidth 
      @ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_06, "999,999.99") FONT cFontName SIZE nFontSize RIGHT
      nCurLine += nFontHeight

      brk_01 := PAY_ID    
      brk_on_01 := .F.
      sum_01_05 := 0 
      sum_01_06 := 0 

   ENDIF

   sum_01_05 := sum_01_05 + EXPENSE   
   sum_01_06 := sum_01_06 + PAYMENT   

   IF nCurLine > nPageSize
      hdr_9982()
   ENDIF

   nCurLine += nFontHeight
   IF prt_01
      nCurCol = nHMargin + 1 * nCharWidth + 6 * nCharWidth 
      @ nCurLine, nCurCol PRINT  TRANSFORM ( PAY_ID, "999") FONT cFontName SIZE nFontSize RIGHT
      prt_01 := .F.
   ENDIF
   nCurCol = nHMargin + 8 * nCharWidth
   @ nCurLine, nCurCol PRINT DATE1      FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 19 * nCharWidth
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYDESC, "XXXXXXXXXXXXXXXXXXXX") FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 40 * nCharWidth
   @ nCurLine, nCurCol PRINT  TRANSFORM ( DESCRIPT, "XXXXXXXXXXXXXXXXXXXX") FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 61 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( EXPENSE, "999,999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 72 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYMENT, "999,999.99") FONT cFontName SIZE nFontSize RIGHT

   DBSKIP()
ENDDO

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
@ nCurLine, nCurCol PRINT replicate("*",  6) FONT cFontName SIZE nFontSize
nCurCol = nHMargin + 61 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1 
nCurCol = nHMargin + 72 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1 

nCurLine += nFontHeight
@ nCurLine,   5 PRINT "sum" FONT cFontName SIZE nFontSize
nCurCol = nHMargin + 61 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_05, "999,999.99") FONT cFontName SIZE nFontSize RIGHT
nCurCol = nHMargin + 72 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_06, "999,999.99") FONT cFontName SIZE nFontSize RIGHT

nCurLine += nFontHeight
nCurCol = nHMargin + 61 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 72 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5

nCurLine += nFontHeight
nCurCol = nHMargin + 61 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_05, "999,999.99") FONT cFontName SIZE nFontSize BOLD RIGHT
nCurCol = nHMargin + 72 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_06, "999,999.99") FONT cFontName SIZE nFontSize BOLD RIGHT

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_2.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_9982

nCurPage++
nCurLine := nVMargin

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT cFontName SIZE nFontSize BOLD
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT cFontName SIZE nFontSize BOLD
@ nCurLine, 100 PRINT "Expense and Payment" FONT cFontName SIZE nFontSize+4 CENTER BOLD

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
@ nCurLine, nCurCol PRINT "PAY_ID" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 8 * nCharWidth
@ nCurLine, nCurCol PRINT "DATE1" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 19 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYDESC" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 40 * nCharWidth
@ nCurLine, nCurCol PRINT "DESCRIPT" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 61 * nCharWidth
@ nCurLine, nCurCol PRINT "EXPENSE" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 72 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYMENT" FONT cFontName SIZE nFontSize BOLD

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
nCurCol2 = nCurCol + 6 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 8 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 19 * nCharWidth
nCurCol2 = nCurCol + 20 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 40 * nCharWidth
nCurCol2 = nCurCol + 20 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 61 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 72 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5

prt_01 := .T.

RETURN 0
*:-----------------------------------------------------------------
function pre_rep2 ( _dat1, _dat2 )

use_cost()

use_report2()
zap

use_payment()

do while .not. eof()

   if date1 < _dat1
      dbskip()
      loop
   endif

   if date1 > _dat2
      dbskip()
      loop
   endif

   _date1 = date1
   _date2 = date2
   _pay_id = pay_id
   _expense = expense
   _payment = payment
   _descript = descript

   select cost
   seek _pay_id
   _paydesc = descript

   select report2
   dbappend()
   replace date1 with _date1
   replace pay_id with _pay_id
   replace paydesc with _paydesc
   replace descript with _descript
   replace expense with _expense
   replace payment with _payment

   select payment
   dbskip()
enddo

dbcloseall()

return
